︠30dd0625-e0ef-441f-b4c1-39249b0a97f5s︠
def basis(c):
    return [prod([(x-c[j])/(c[i]-c[j]) for j in range(len(c)) if j != i]) for i in range(len(c))]

def rep(p, c):
    return matrix([p(x = c[i]) for i in range(len(c))]).T

def A(c, d): # matrtix converting from c to d
    B = basis(c)
    return matrix([vector(rep(B[i],d)) for i in range(len(d))]).T
︡5555fd37-47c0-47d4-b2ad-b733f52a64a2︡{"done":true}
︠09c9b29c-e275-4f93-9e4a-f323df616fba︠
%md
Change $c$ an $d$ below to determine two basis.
︡f2796c0b-5c0c-43a0-b358-8b8b3b7ee166︡{"done":true,"md":"Change $c$ an $d$ below to determine two basis."}
︠b0924055-9f4b-4437-8434-1813d677ccdfs︠
c = [-2,-1,0,1,2]
d = [1,2,3,4,5]
Bc = basis(c)
Bd = basis(d)
A = A(c, d)

︡e3f19101-d837-4862-b526-d763474215f6︡{"done":true}
︠e712d33b-5f2d-4b85-a3ab-572599d13c68s︠
str1 = "\\begin{align}"
str1 += ' '.join([f"q_{i}^c &= {latex(Bc[i])}={latex(Bc[i].simplify_full())}\\\\" for i in range(len(c))])
str1 += "\\end{align}"
html(str1)
︡ab6fe840-f441-4605-9043-697f60872fae︡{"html":"\\begin{align}q_0^c &= \\frac{1}{24} \\, {\\left(x + 1\\right)} {\\left(x - 1\\right)} {\\left(x - 2\\right)} x=\\frac{1}{24} \\, x^{4} - \\frac{1}{12} \\, x^{3} - \\frac{1}{24} \\, x^{2} + \\frac{1}{12} \\, x\\\\ q_1^c &= -\\frac{1}{6} \\, {\\left(x + 2\\right)} {\\left(x - 1\\right)} {\\left(x - 2\\right)} x=-\\frac{1}{6} \\, x^{4} + \\frac{1}{6} \\, x^{3} + \\frac{2}{3} \\, x^{2} - \\frac{2}{3} \\, x\\\\ q_2^c &= \\frac{1}{4} \\, {\\left(x + 2\\right)} {\\left(x + 1\\right)} {\\left(x - 1\\right)} {\\left(x - 2\\right)}=\\frac{1}{4} \\, x^{4} - \\frac{5}{4} \\, x^{2} + 1\\\\ q_3^c &= -\\frac{1}{6} \\, {\\left(x + 2\\right)} {\\left(x + 1\\right)} {\\left(x - 2\\right)} x=-\\frac{1}{6} \\, x^{4} - \\frac{1}{6} \\, x^{3} + \\frac{2}{3} \\, x^{2} + \\frac{2}{3} \\, x\\\\ q_4^c &= \\frac{1}{24} \\, {\\left(x + 2\\right)} {\\left(x + 1\\right)} {\\left(x - 1\\right)} x=\\frac{1}{24} \\, x^{4} + \\frac{1}{12} \\, x^{3} - \\frac{1}{24} \\, x^{2} - \\frac{1}{12} \\, x\\\\\\end{align}"}︡{"done":true}
︠9ba3adea-4477-4c04-9bfc-94e86a2ba039s︠
str2 = "\\begin{align}"
str2 += ' '.join([f"q_{i}^d &= {latex(Bd[i])}={latex(Bd[i].simplify_full())}\\\\" for i in range(len(d))])
str2 += "\\end{align}"
html(str2)
︡bec3663a-546e-45b4-a134-5d6dab677424︡{"html":"\\begin{align}q_0^d &= \\frac{1}{24} \\, {\\left(x - 2\\right)} {\\left(x - 3\\right)} {\\left(x - 4\\right)} {\\left(x - 5\\right)}=\\frac{1}{24} \\, x^{4} - \\frac{7}{12} \\, x^{3} + \\frac{71}{24} \\, x^{2} - \\frac{77}{12} \\, x + 5\\\\ q_1^d &= -\\frac{1}{6} \\, {\\left(x - 1\\right)} {\\left(x - 3\\right)} {\\left(x - 4\\right)} {\\left(x - 5\\right)}=-\\frac{1}{6} \\, x^{4} + \\frac{13}{6} \\, x^{3} - \\frac{59}{6} \\, x^{2} + \\frac{107}{6} \\, x - 10\\\\ q_2^d &= \\frac{1}{4} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 4\\right)} {\\left(x - 5\\right)}=\\frac{1}{4} \\, x^{4} - 3 \\, x^{3} + \\frac{49}{4} \\, x^{2} - \\frac{39}{2} \\, x + 10\\\\ q_3^d &= -\\frac{1}{6} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 3\\right)} {\\left(x - 5\\right)}=-\\frac{1}{6} \\, x^{4} + \\frac{11}{6} \\, x^{3} - \\frac{41}{6} \\, x^{2} + \\frac{61}{6} \\, x - 5\\\\ q_4^d &= \\frac{1}{24} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 3\\right)} {\\left(x - 4\\right)}=\\frac{1}{24} \\, x^{4} - \\frac{5}{12} \\, x^{3} + \\frac{35}{24} \\, x^{2} - \\frac{25}{12} \\, x + 1\\\\\\end{align}"}︡{"done":true}
︠4124bfd9-0f29-478d-b6ff-1a4f2d5f73c4s︠
p(x) = 1 - 2*x^2 + 4*x^4
html(f"$$[p]_{{\\cal q^c}}={latex(rep(p, c))};\\quad[p]_{{\\cal q^d}}={latex(rep(p, d))}$$")
︡624cfed2-f657-44f8-9a57-09c5c45a278c︡{"html":"$$[p]_{\\cal q^c}=\\left(\\begin{array}{r}\n57 \\\\\n3 \\\\\n1 \\\\\n3 \\\\\n57\n\\end{array}\\right);\\quad[p]_{\\cal q^d}=\\left(\\begin{array}{r}\n3 \\\\\n57 \\\\\n307 \\\\\n993 \\\\\n2451\n\\end{array}\\right)$$"}︡{"done":true}
︠de66a4e3-1d5d-4731-831d-c33cad0ea012s︠

︡420b856f-69b0-4748-81cb-c542ba66b0dc︡{"done":true}
︠cd5ec996-c382-43c1-857c-ea1092e40df4s︠
str3 = f"$$A_{{\\cal Q^c,Q^d}}[p]_{{\\cal q^c}} = {latex(A)}{latex(rep(p, c))}={latex(A*matrix(rep(p, c)))}=[p]_{{\\cal q^d}}$$"
html(str3)
︡74e05fc6-8c6f-4df0-a7cd-6c50fbce9a91︡{"html":"$$A_{\\cal Q^c,Q^d}[p]_{\\cal q^c} = \\left(\\begin{array}{rrrrr}\n0 & 0 & 0 & 1 & 0 \\\\\n0 & 0 & 0 & 0 & 1 \\\\\n1 & -5 & 10 & -10 & 5 \\\\\n5 & -24 & 45 & -40 & 15 \\\\\n15 & -70 & 126 & -105 & 35\n\\end{array}\\right)\\left(\\begin{array}{r}\n57 \\\\\n3 \\\\\n1 \\\\\n3 \\\\\n57\n\\end{array}\\right)=\\left(\\begin{array}{r}\n3 \\\\\n57 \\\\\n307 \\\\\n993 \\\\\n2451\n\\end{array}\\right)=[p]_{\\cal q^d}$$"}︡{"done":true}
︠ddbb5687-e51a-44a3-82df-1e00eac3397bs︠
n = 4
str4 = f"\\begin{{split}}{latex(Bc[n])}&={latex(Bc[n].simplify_full())}\\\\&={latex(vector(Bd)*A[:,n])}\\\\&={latex((vector(Bd)*A[:,n])[0].simplify_full())}\\end{{split}}"
html(str4)
︡c8d749d6-1cc1-450f-a85c-a01cafd894c9︡{"html":"\\begin{split}\\frac{1}{24} \\, {\\left(x + 2\\right)} {\\left(x + 1\\right)} {\\left(x - 1\\right)} x&=\\frac{1}{24} \\, x^{4} + \\frac{1}{12} \\, x^{3} - \\frac{1}{24} \\, x^{2} - \\frac{1}{12} \\, x\\\\&=\\left(\\frac{35}{24} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 3\\right)} {\\left(x - 4\\right)} - \\frac{5}{2} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 3\\right)} {\\left(x - 5\\right)} + \\frac{5}{4} \\, {\\left(x - 1\\right)} {\\left(x - 2\\right)} {\\left(x - 4\\right)} {\\left(x - 5\\right)} - \\frac{1}{6} \\, {\\left(x - 1\\right)} {\\left(x - 3\\right)} {\\left(x - 4\\right)} {\\left(x - 5\\right)}\\right)\\\\&=\\frac{1}{24} \\, x^{4} + \\frac{1}{12} \\, x^{3} - \\frac{1}{24} \\, x^{2} - \\frac{1}{12} \\, x\\end{split}"}︡{"done":true}
︠54afcbf1-d3a3-4232-964a-e1c95a810309s︠
latex(A)
︡85e52816-c96c-49f9-adb2-b23f3fcb57a8︡{"stdout":"\\left(\\begin{array}{rrrrr}\n0 & 0 & 0 & 1 & 0 \\\\\n0 & 0 & 0 & 0 & 1 \\\\\n1 & -5 & 10 & -10 & 5 \\\\\n5 & -24 & 45 & -40 & 15 \\\\\n15 & -70 & 126 & -105 & 35\n\\end{array}\\right)\n"}︡{"done":true}
︠c94a9abf-2e52-4e00-bf07-236dbe36b7fes︠
︡a08a3261-27d3-4c7d-a497-cc21f84e88e7︡{"done":true}
︠cb7815c3-d436-4b15-a8dc-9bd7338e366f︠









